diamante = {}

img_diamante = {}
for i=0,5 do
	img_diamante[0]=love.graphics.newImage("gfx/diamond_0.png")
end

function diamante:add(x,y,c)
	self[#self+1]= {
		x=x,
		y=y,
		cor=c,
		frame=0,
		tempo=love.timer.getMicroTime(),
		exibe=true
	}
end

function diamante:draw()
	local jx,jy,jl,ja=jogador.x,jogador.y,img_jogador[jogador.frame]:getWidth(),img_jogador[jogador.frame]:getHeight()
	local dl,da=32,32
	love.graphics.setColor(255,255,255,255)
	if exibe_mapa then love.graphics.setColor(100,100,100,100) end
	for i=1,#diamante do
		if diamante[i].exibe==true then
			d=diamante[i]
			local quad = love.graphics.newQuad(d.frame*32,0,32,32,256,32)
			love.graphics.drawq(img_diamante[d.cor],quad,d.x,d.y)
			if love.timer.getMicroTime()>=d.tempo+.050 then
				d.tempo=love.timer.getMicroTime()
				d.frame=d.frame+1
				if d.frame==8 then
					d.frame=0
				end
			end
			if checa_colisao(jx,jy,jl,ja,d.x,d.y,dl,da) then
				efeito:apaga("luz_"..i)
				diamante[i].exibe=false
				jogador.diamantes=jogador.diamantes+1
				jogador.fase_total_diamantes=jogador.fase_total_diamantes-1
				if jogador.fase_total_diamantes==0 then
					jogador.level_completo=true
					tempo_entre_fases=love.timer.getMicroTime()
				end
				for j=1,5 do
					efeito:add(d.x,d.y,"estrela")
				end
			end
		end
	end
end

function diamante:atualiza_posicao_x()
	for i=1,#diamante,1 do
		if diamante[i]~=nil then
			d=diamante[i]
			if string.find(jogador.direcao,"right")~=nil then
				d.x=d.x-val_x_atualiza_mundo
			elseif string.find(jogador.direcao,"left")~=nil then
				d.x=d.x+val_x_atualiza_mundo
			end
		end
	end
end

function diamante:apaga()
	for i=1,#diamante do
		diamante[i]=nil
	end
end
