
jogador = {}

img_jogador = {}

img_jogador[0]=love.graphics.newImage("gfx/guy_front.png")

img_jogador[1]=love.graphics.newImage("gfx/guy0001_left.png")
img_jogador[2]=love.graphics.newImage("gfx/guy0002_left.png")
img_jogador[3]=love.graphics.newImage("gfx/guy0003_left.png")
img_jogador[4]=love.graphics.newImage("gfx/guy0004_left.png")
img_jogador[5]=love.graphics.newImage("gfx/guy0005_left.png")
img_jogador[6]=love.graphics.newImage("gfx/guy0006_left.png")
img_jogador[7]=love.graphics.newImage("gfx/guy0007_left.png")
img_jogador[8]=love.graphics.newImage("gfx/guy0008_left.png")
img_jogador[9]=love.graphics.newImage("gfx/guy0009_left.png")
img_jogador[10]=love.graphics.newImage("gfx/guy0010_left.png")

img_jogador[11]=love.graphics.newImage("gfx/guy0001_right.png")
img_jogador[12]=love.graphics.newImage("gfx/guy0002_right.png")
img_jogador[13]=love.graphics.newImage("gfx/guy0003_right.png")
img_jogador[14]=love.graphics.newImage("gfx/guy0004_right.png")
img_jogador[15]=love.graphics.newImage("gfx/guy0005_right.png")
img_jogador[16]=love.graphics.newImage("gfx/guy0006_right.png")
img_jogador[17]=love.graphics.newImage("gfx/guy0007_right.png")
img_jogador[18]=love.graphics.newImage("gfx/guy0008_right.png")
img_jogador[19]=love.graphics.newImage("gfx/guy0009_right.png")
img_jogador[20]=love.graphics.newImage("gfx/guy0010_right.png")

img_jogador[21]=love.graphics.newImage("gfx/guy_jump_left.png")
img_jogador[22]=love.graphics.newImage("gfx/guy_jump_right.png")

img_jogador[23]=love.graphics.newImage("gfx/guy_front_icon.png")

function jogador:new()

	jogador:reset()

	self.status_fase=0
	self.moeda_ouro=0
	self.moeda_prata=0
	self.moeda_bronze=0
	self.diamantes=0
	self.fase_total_diamantes=0
	self.vidas=5
	self.x = 50
	self.y = 400
	self.max_vidas=self.vidas

	self.atingido=false
	self.chave_verde=false
	self.chave_vermelha=false
	self.chave_azul=false
	self.chave_amarela=false
	self.game_over=false
	self.level_completo=false
end

function jogador:reset()
	if self.vivo==false then
		self.vidas=jogador.vidas-1
		if self.vidas==0 then
			self.game_over=true
		end
	end
	self.vivo=true
	self.colisao=false
	self.atualiza_mundo_x=false
	self.atualiza_mundo_y=false
	self.exibe=true
	self.afundando=false

	self.direcao=""
	self.posicao_colisao="on_top"
	self.objeto_colisao=""

	self.y = -100
	self.frame=0
	self.vel_y=0
	self.vel_x=0
	self.vel_run=7
	self.vel_run_minimo=7
	if ambiente=="deserto" then self.vel_run_minimo=5 end
	self.pulo=0
	self.mundo_escorrega=0
	self.tempo_pisca=0
	self.tempo_atingido=0
	self.tempo_afundando=0
	self.vel_deslizar=0
end

function jogador:timeup()
	self.status_fase=0
	self.moeda_ouro=0
	self.moeda_prata=0
	self.moeda_bronze=0
	self.diamantes=0
	self.fase_total_diamantes=0
	self.x = 50
	self.y = 400

	self.atingido=false
	self.chave_verde=false
	self.chave_vermelha=false
	self.chave_azul=false
	self.chave_amarela=false
	self.game_over=false
	self.level_completo=false

	self.vivo=true
	self.colisao=false
	self.atualiza_mundo_x=false
	self.atualiza_mundo_y=false
	self.exibe=true
	self.afundando=false

	self.direcao=""
	self.posicao_colisao="on_top"
	self.objeto_colisao=""

	self.frame=0
	self.vel_y=0
	self.vel_x=0
	self.vel_run=7
	self.vel_run_minimo=7
	if ambiente=="deserto" then self.vel_run_minimo=5 end
	self.pulo=0
	self.mundo_escorrega=0
	self.tempo_pisca=0
	self.tempo_atingido=0
	self.tempo_afundando=0
	self.vel_deslizar=0
end

function jogador:testa_fase()
	if tempo_fase<=0 and self.fase_total_diamantes>0 then
		self.status_fase=-1
		self.vidas=jogador.vidas-1
		if self.vidas==0 then
			self.game_over=true
		end
	end
end

function jogador:draw()
	local a=255
	if self.afundando==true then a=150 end
	if exibe_mapa then a=100 end
	love.graphics.setColor(255,255,255,a)

	if self.exibe==true then
		love.graphics.draw(img_jogador[self.frame],self.x,self.y)
	end
end

function jogador:control(key)
	if self.vivo and self.afundando==false then
		self.direcao=key
		if self.pulo==0 then
			if key=="right" then
				if self.frame<11 then
					self.frame=11
				else
					self.frame=self.frame+1
					if self.frame>20 then
						self.frame=11
					end
				end
			elseif key=="left" then
				if self.frame>10 then
					self.frame=1
				else
					self.frame=self.frame+1
					if self.frame>10 then
						self.frame=1
					end
				end
			end
		end

		if love.keyboard.isDown("left") and love.keyboard.isDown("right") then
			self.frame=0
			self.direcao=""
		end

		if string.find(key,"up")~=nil then
			if key=="up_" then
				self.frame=0
			elseif key=="up_left" then
				self.frame=21
			elseif key=="up_right" then
				self.frame=22
			end
			if self.pulo==0 then
				self.pulo=1
				self.vel_y=-15
				if self.vel_run>self.vel_run_minimo then
					v=(self.vel_run/self.vel_run_minimo)
					v=math.floor(2*v)
					self.vel_y=self.vel_y-v
				end
				self.vel_deslizar=0
			end
		end
	end
end

function jogador:atualiza_posicao()

	if self.vivo==false then
		self.vel_y=self.vel_y+gravidade
		self.y=self.y+self.vel_y

		if love.timer.getMicroTime()>=self.tempo_pisca+0.08 then
			self.tempo_pisca=love.timer.getMicroTime()
			self.exibe=not self.exibe
		end

		if self.y>res_y then
			self:reset()
		end

		return
	end

	if self.atingido==true then
		if love.timer.getMicroTime()>=self.tempo_pisca+0.08 then
			self.tempo_pisca=love.timer.getMicroTime()
			self.exibe=not self.exibe
		end
		if love.timer.getMicroTime()>=self.tempo_atingido+4 then
			self.atingido=false
			self.tempo_atingido=0
			self.exibe=true
		end
	end

	if self.afundando==true then
		self.vel_y=self.vel_y+gravidade
		self.y=self.y+self.vel_y
		if self.y>res_y or love.timer.getMicroTime()>=self.tempo_afundando+500 then
			self.vivo=false
			self:reset()
		end
		return
	end

	local x=self.x
	local y=0

	if string.find(self.direcao,"left")~=nil then
		x=x-self.vel_run --7
	elseif string.find(self.direcao,"right")~=nil then
		x=x+self.vel_run --7
	end
	if self.direcao=="" or (self.vel_deslizar>0 and self.direcao=="left") or (self.vel_deslizar<0 and self.direcao=="right") then
		x=x+self.vel_deslizar
		if self.vel_deslizar<0 then
			self.vel_deslizar=self.vel_deslizar+.5
			if self.vel_deslizar>0 then self.vel_deslizar=0 end
		elseif self.vel_deslizar>0 then
			self.vel_deslizar=self.vel_deslizar-.5
			if self.vel_deslizar<0 then self.vel_deslizar=0 end
		end
	end
	mundo:testa_colisao_jogador(x,self.y)
	if x<=0 or x+img_jogador[self.frame]:getWidth()>=res_x then
		self.colisao=true
	end

	if self.colisao==false then
		if self.atualiza_mundo_x==false then
			self.x=x
		end
	end


	self.vel_y=self.vel_y+gravidade
	y=self.y+self.vel_y
	mundo:testa_colisao_jogador(self.x,y)
	if jogador.colisao==false then
		self.y=y
		if string.find(self.direcao,"up_")==nil then
			self.direcao="up_"..self.direcao
		end
		self.pulo=1
		if self.vel_deslizar<0 then
			self.vel_deslizar=self.vel_deslizar+.5
			if self.vel_deslizar>0 then self.vel_deslizar=0 end
		elseif self.vel_deslizar>0 then
			self.vel_deslizar=self.vel_deslizar-.5
			if self.vel_deslizar<0 then self.vel_deslizar=0 end
		end
	else
		self.vel_y=0
		self.pulo=0
	end

	if self.mundo_escorrega>0 and self.direcao=="" then
		jm=self.x+(img_jogador[self.frame]:getWidth()/2)
		mm=mundo[self.mundo_escorrega].x+(mundo[self.mundo_escorrega].img:getWidth()/2)
		if jm-mm>40 then
			self.vel_x=self.vel_x+gravidade
			self.x=self.x+self.vel_x
			self.frame=22
		elseif jm-mm<-40 then
			self.vel_x=self.vel_x+gravidade
			self.x=self.x-self.vel_x
			self.frame=21
		end
	end

	if self.y>res_y then
		self.vivo=false
	end

end

function jogador:checa_atualiza_mundo()
	if (self.x+img_jogador[self.frame]:getWidth()>=res_x-550 and string.find(self.direcao,"right")~=nil) or (self.x<=550 and string.find(self.direcao,"left")~=nil) then
		self.atualiza_mundo_x=true
	else
		self.atualiza_mundo_x=false
	end

	if (string.find(self.direcao,"left")~=nil and self.x<=550 and mundo[1].x>=0) or (string.find(self.direcao,"right")~=nil and self.x+img_jogador[self.frame]:getWidth()>=res_x-550 and mundo[#mundo].x+70<=res_x) then
		self.atualiza_mundo_x=false
	end

	if self.atualiza_mundo_x==true then
		local jx,jy,jl,ja=self.x,self.y,img_jogador[self.frame]:getWidth(),img_jogador[self.frame]:getHeight()
		local ok
		for i=1,#mundo do
			m=mundo[i]
			if m.nome_img=="base" or string.find(m.nome_img,"ground")~=nil or m.nome_img=="block" or m.nome_img=="bridge" or string.find(m.nome_img,"bonus")~=nil or m.nome_img=="plank" or string.find(m.nome_img,"spikes")~=nil or m.nome_img=="crate" or (m.nome_img=="ballon" and m.explodido==false) or (m.nome_img=="lock" and m.explodido==false) then
				if (m.x>=0 and m.x+m.img:getWidth()<=res_x) or (m.y+m.img:getHeight()>=0 and m.y<=res_y) then
					ml=m.img:getWidth()
					ma=m.img:getHeight()
					if string.find(self.direcao,"right")~=nil then
						x=m.x-val_x_atualiza_mundo
					elseif string.find(self.direcao,"left")~=nil then
						x=m.x+val_x_atualiza_mundo
					end
					if checa_colisao(jx,jy,jl,ja,x,m.y,ml,ma) then
						self.atualiza_mundo_x=false
						break
					end
				end
			end
		end
	end

end
