
res_x=1024
res_y=768

require("mundo")
require("jogador")
require("moeda")
require("efeito")
require("inimigo")
require("chave")
require("diamante")
require("tempo")
require("cenario")

gravidade=.50
tempo_tiro=love.timer.getMicroTime()

paused=false
exibe_mapa=false
move_mapa=""
ambiente=""
campo_visao=0
tempo_trovao={}
tempo_trovao[0]=0
tempo_trovao[1]=0
tempo_trovao[2]=0
val_x_atualiza_mundo=0

fase=1
tempo_fase=0
tempo_entre_fases=0
fim_x_mapa=0

fonte=love.graphics.newFont("Sniglet.ttf",25)
fontef2=love.graphics.newFont("Sniglet.ttf",20)

function love.load()

	math.randomseed(os.time())

	ok=love.graphics.setMode(res_x,res_y,false,false)

	love.mouse.setVisible(false)

	tempo_frame=0

	jogador:new()
	mundo:reset()

	res_x=1708
	res_y=1281

end

function love.update(dt)
	if love.keyboard.isDown("tab") then
		exibe_mapa=true
	else
		exibe_mapa=false
	end

	if paused==false and exibe_mapa==false and jogador.game_over==false and jogador.level_completo==false and jogador.status_fase==0 then
		tempo_fase=tempo_fase-dt
		jogador:testa_fase()
		if 	tempo_frame==0 then
			key=""
			if love.keyboard.isDown("left") then
				key="left"
			elseif love.keyboard.isDown("right") then
				key="right"
			end
			if jogador.posicao_colisao=="on_top" and (love.keyboard.isDown("up") or jogador.pulo==1) then
				key="up_"..key
			end

			jogador:control(key)
			moeda:testa_colisao_mundo()
			inimigo:testa_colisao_mundo()
			chave:testa_colisao_jogador()
			chave:cria_efeito()
			jogador:checa_atualiza_mundo()
			if jogador.atualiza_mundo_x==true then
				colinas:atualiza_posicao_x()
				mundo:atualiza_posicao_x()
				moeda:atualiza_posicao_x()
				efeito:atualiza_posicao_x()
				inimigo:atualiza_posicao_x()
				chave:atualiza_posicao_x()
				diamante:atualiza_posicao_x()
				cenariofrente:atualiza_posicao_x()
				cenarioatras:atualiza_posicao_x()
			end
			jogador:atualiza_posicao()

			if jogador.pulo==0 then
				if love.keyboard.isDown("lshift") then
					v=13
					if jogador.vel_run_minimo==5 then v=10 end
					if jogador.vel_run<v then jogador.vel_run=jogador.vel_run+1 end
				else
					if jogador.vel_run>jogador.vel_run_minimo then jogador.vel_run=jogador.vel_run-1 end
				end
			else
				if jogador.vel_run>jogador.vel_run_minimo then jogador.vel_run=jogador.vel_run-1 end
			end

			if #nuvem>0 then
				for i=1,#nuvem do
					n=nuvem[i]
					n.x=n.x+n.vel_x
					if n.vel_x<0 and n.x+n.img:getWidth()<mundo[1].x then
						n.x=n.x+80
						n.y=math.random(mundo[1].y,mundo[1].y+150)
					end
					if n.vel_x>0 and n.x>mundo[#mundo].x+80 then
						n.x=mundo[1].x-(n.img:getWidth()+10)
						n.y=math.random(mundo[1].y,mundo[1].y+150)
					end
					if jogador.atualiza_mundo_x==true then
						if string.find(jogador.direcao,"right")~=nil then
							n.x=n.x-jogador.vel_run
						elseif string.find(jogador.direcao,"left")~=nil then
							n.x=n.x+jogador.vel_run
						end
					end
					dist=math.floor(math.abs(math.dist(jogador.x,jogador.y,n.x,n.y)))
					if dist<=300 then
						n.alfa=255
						n.mapa_visivel=true
					else
						dif=dist-300
						n.alfa=255-dif
						if n.alfa<=0 then n.alfa=0 end
					end
				end
			end
		end
		tempo_frame=tempo_frame+dt
		if tempo_frame>=.02 then
			tempo_frame=0
		end
	end
end

function love.draw()

	love.graphics.setFont(fonte)
	t=0
	if love.timer.getFPS()<150 then t=2 end
	if love.timer.getFPS()<100 then t=4 end

	love.graphics.clear()
	love.graphics.scale(0.6,0.6)

	love.graphics.setColor(255,255,255,255)
	love.graphics.setBackgroundColor(0,0,0)
	love.graphics.draw(img_ceu,0,0,0,200,1)
	love.graphics.draw(img_fundo,0,600,0,200,1.13)

	--love.graphics.setColor(100,100,100,255)
	--love.graphics.rectangle("fill",0,600,res_x,res_y-600)

	love.graphics.setColor(255,255,255,255)
	if exibe_mapa==false then
		for i=0,2 do
			if love.timer.getMicroTime()>=tempo_trovao[i]-.15 then
				love.graphics.setBackgroundColor(255,255,255)
				if love.timer.getMicroTime()>=tempo_trovao[i] then
					tempo_trovao[i]=love.timer.getMicroTime()+math.random(4,8)
				end
			end
		end
	end

	if #nuvem>0 then
		for i=1,#nuvem do
			n=nuvem[i]
			love.graphics.setColor(255,255,255,n.alfa)
			if exibe_mapa then
				alfa=n.alfa-150
				if alfa<=0 then alfa=0 end
				love.graphics.setColor(255,255,255,alfa)
			end
			love.graphics.draw(n.img,n.x,n.y)
		end
	end

	love.graphics.setColor(255,255,255,255)

	colinas:draw()
	cenarioatras:draw()
	if jogador.vivo==true then jogador:draw() end
	inimigo:draw()
	mundo:draw(t)
	cenariofrente:draw()
	moeda:draw()
	chave:draw()
	if jogador.vivo==false then jogador:draw() end
	mundo:exibe_icones()
	efeito:draw()
	diamante:draw()

	if string.find(ambiente,"chuva")~=nil or string.find(ambiente,"neve")~=nil then
		tempo:draw()
	end

	if exibe_mapa==false then
		love.graphics.scale(2,2)
		if paused then
			love.graphics.setColor(0,0,0,255)
			love.graphics.printf("Game paused",1,29,800,"center")
			love.graphics.setColor(255,255,255,255)
			love.graphics.printf("Game paused",0,28,800,"center")
		elseif jogador.game_over then
			love.graphics.setColor(0,0,0,255)
			love.graphics.printf("Game Over!",1,29,800,"center")
			love.graphics.setColor(255,255,255,255)
			love.graphics.printf("Game Over!",0,28,800,"center")
			f2()
		elseif jogador.level_completo then
			love.graphics.setColor(0,0,0,255)
			love.graphics.printf("Congratulations!! You've completed the level!",1,29,800,"center")
			love.graphics.setColor(255,255,255,255)
			love.graphics.printf("Congratulations!! You've completed the level!",0,28,800,"center")
			if love.timer.getMicroTime()>=tempo_entre_fases+3 and fase<3 then
				fase=fase+1
				mundo:apaga()
			else
				fase=1
				f2()
			end
		elseif jogador.status_fase==-1 then
			love.graphics.setColor(0,0,0,255)
			love.graphics.printf("You've failed to complete the level.",1,29,800,"center")
			love.graphics.setColor(255,255,255,255)
			love.graphics.printf("You've failed to complete the level.",0,28,800,"center")
			f2()
		end
		tempo_fase=math.abs(tempo_fase)
		love.graphics.print(love.timer.getFPS(),5,40)
		love.graphics.setColor(0,0,0)
		love.graphics.printf(string.format("%.1f",tempo_fase),1,6,800,"center")
		love.graphics.setColor(255,255,255)
		if tempo_fase<6 then love.graphics.setColor(255,70,70) end
		love.graphics.printf(string.format("%.1f",tempo_fase),0,5,800,"center")
	end

	if exibe_mapa then
		love.graphics.scale(2,2)
		love.graphics.setColor(0,0,0,255)
		love.graphics.printf("Level "..fase,1,6,800,"center")
		love.graphics.printf("Map",1,29,800,"center")
		love.graphics.setColor(255,255,255,255)
		love.graphics.printf("Level "..fase,0,5,800,"center")
		love.graphics.printf("Map",0,28,800,"center")
		love.graphics.scale(0.5,0.5)
		mundo:exibe_mapa()
	end

end

function love.keyreleased(key)
	if jogador.pulo==0 then
		jogador.frame=0
	end
	jogador.tempo_frame=0
	move_mapa=""
end

function love.keypressed(key, unicode)
	if key=="escape" then
		love.event.quit()
	end
	if key=="f10" then
		ok=love.graphics.toggleFullscreen()
		tempo:ceus()
	end

	if jogador.game_over==false and jogador.status_fase==0 and jogador.level_completo==false then
		if key=="pause" then
			paused=not paused
		end
		if exibe_mapa then
			if key=="left" then
				move_mapa="left"
			elseif key=="right"then
				move_mapa="right"
			end
			if love.keyboard.isDown("left") and love.keyboard.isDown("right") then move_mapa="" end
		end
	else
		if key=="f2" then
			if jogador.status_fase==0 or jogador.game_over then
				jogador:new()
			else
				jogador:timeup()
			end

			res_x=1708
			res_y=1281

			mundo:apaga()
			mundo:reset()

		end
	end
end

function love.mousepressed(x, y, k)

end

function love.mousereleased(x, y, k)

end

function checa_colisao(ax1,ay1,aw,ah, bx1,by1,bw,bh)
	local ax2,ay2,bx2,by2 = ax1 + aw, ay1 + ah, bx1 + bw, by1 + bh

	return ax1 < bx2 and ax2 > bx1 and ay1 < by2 and ay2 > by1
end

function math.dist(x1,y1, x2,y2)
	return ((x2-x1)^2+(y2-y1)^2)^0.5
end

function love.focus(hasFocus)
	if not hasFocus then
		paused=true
	else
		paused=false
	end
end

function f2()
	love.graphics.setFont(fontef2)
	love.graphics.setColor(0,0,0,255)
	love.graphics.printf("Press F2 to restart.",1,52,800,"center")
	love.graphics.setColor(255,255,255,255)
	love.graphics.printf("Press F2 to restart.",0,51,800,"center")
	love.graphics.setFont(fonte)
end
