mundo = {}

icones_diamantes={}

function mundo:add(x,y,nome_img,tipo,cor)
	self[#self+1] = {
		x=x,
		ini_x=x,
		mapa_x=x,
		y=y,
		ini_y=y,
		nome_img=nome_img,
		vel_x=0,
		tipo=tipo,
		dir="",
		exibe=1,
		img="",
		colisao_jogador=false,
		colisao_moeda=false,
		colisao=false,
		cor=cor,
		tempo_treme=0,
		tempo_explosao=0,
		tempo_cria_efeito=0,
		qtd_explosao=0,
		explodido=false,
		a=0,
		mapa_visivel=false
	}
	if nome_img~="limite" and nome_img~="img_ceu" and nome_img~="ballon" and nome_img~="lock" then
		self[#self].img=love.graphics.newImage("gfx/"..nome_img..".png")
		if nome_img=="plank" then
			if tipo=="vert" then self[#self].dir="up" end
			if tipo=="horz" then self[#self].dir="right" end
		end
	end
	if nome_img=="ballon" or nome_img=="lock" then
		self[#self].img=love.graphics.newImage("gfx/"..nome_img.."_"..cor..".png")
		if nome_img=="ballon" then
			self[#self].vel_x=.0025
			if cor=="green" then
				self[#self].tempo_treme=love.timer.getMicroTime()+2.5
			elseif cor=="blue" then
				self[#self].tempo_treme=love.timer.getMicroTime()+2
			elseif cor=="yellow" then
				self[#self].tempo_treme=love.timer.getMicroTime()+1.5
			elseif cor=="red" then
				self[#self].tempo_treme=love.timer.getMicroTime()+1
			end
		end
	end

end

function mundo:draw(dt)
	local jx,jy,jl,ja=jogador.x,jogador.y,img_jogador[jogador.frame]:getWidth(),img_jogador[jogador.frame]:getHeight()
	local mx,my,ml,ma=0,0,0,0
	local c=0
	jogador.mundo_escorrega=0
	for i=1,#mundo do
		m=mundo[i]
		if m.nome_img~="limite" then
			if exibe_mapa==false then
				if (m.x>=-80 and m.x+m.img:getWidth()<=res_x+80) then
					if m.nome_img=="plank" then
						if m.tipo=="vert" then
							if m.dir=="down" then
								if math.floor(math.abs(m.y-m.ini_y))<=250 then
									m.y=m.y+.75 --(.25+(dt/8))
									if jogador.objeto_colisao=="plank_vert" then
										jogador.y=jogador.y+.75 --(.25+(dt/8))
										d=jogador.y+img_jogador[jogador.frame]:getHeight()-m.y
										if d>0 then
											jogador.y=jogador.y-d
										end
									end
								else
									m.dir="up"
								end
							elseif m.dir=="up" then
								if math.floor(math.abs(m.y-m.ini_y))>0 then
									m.y=m.y-.75 --(.25+(dt/8))
									if jogador.objeto_colisao=="plank_vert" then
										jogador.y=jogador.y-.75 --(.25+(dt/8))
										d=jogador.y+img_jogador[jogador.frame]:getHeight()-m.y
										if d>0 then
											jogador.y=jogador.y-d
										end
									end
								else
									m.dir="down"
								end
							end
						end
					end
					if m.nome_img=="bonus" then
						if m.tipo=="hit_up" then
							if math.abs(m.y-m.ini_y)<=50 then
								m.y=m.y-(2+dt)
							else
								m.tipo="hit_down"
								m.img=love.graphics.newImage("gfx/bonus_used.png")
								if m.cor=="" then
									for j=1,10 do
										dir=math.random(-1,1)
										if dir==0 then dir=1 end
										vx=math.random(1,4)*dir
										vy=math.random(3,8)
										moeda:add(m.x+(m.img:getWidth()/2),m.y-40,math.random(1,3),vx,vy,dir)
									end
								else
									chave:add(m.x+5,m.y-40,m.cor)
								end
							end
						end
						if m.tipo=="hit_down" then
							if math.abs(m.y-m.ini_y)>0 then
								m.y=m.y+(2+dt)
							else
								m.tipo="used"
							end
						end
					end

					if m.nome_img=="base" then
						if math.abs(jogador.x-m.x)<=400 and math.abs(jogador.y-m.y)<=400 then
							inimigo:cria_tiro(i)
						end
					end

					if m.nome_img=="ballon" then
						if m.explodido==false then
							if love.timer.getMicroTime()>=m.tempo_treme then
								if m.dir=="esq" then
									if m.x-m.ini_x>-6 then
										m.x=m.x-m.vel_x
									else
										m.dir="dir"
									end
								else
									if m.x-m.ini_x<6 then
										m.x=m.x+m.vel_x
									else
										m.dir="esq"
									end
								end
								m.vel_x=m.vel_x+.025
								if love.timer.getMicroTime()>=m.tempo_treme+1.5 then
									m.tempo_explosao=love.timer.getMicroTime()
									m.explodido=true
									m.tempo_cria_efeito=love.timer.getMicroTime()
								end
							end
						end
						if m.explodido==true and love.timer.getMicroTime()>=m.tempo_cria_efeito+.025 then
							if m.qtd_explosao<4 then
								m.qtd_explosao=m.qtd_explosao+1
								m.tempo_cria_efeito=love.timer.getMicroTime()
								efeito:add(math.random(m.x-10,m.x+23),math.random(m.y-10,m.y+30),"sparkle_ballon","")
							end
						end
					end

					if m.nome_img=="limite" then m.exibe=4 end
					dist=math.floor(math.abs(math.dist(jogador.x,jogador.y,m.x,m.y)))
					if dist<=campo_visao then
						m.a=255
						m.mapa_visivel=true
					else
						dif=dist-campo_visao
						m.a=255-dif
						if m.a<=0 then m.a=0 end
						if m.a>0 then
							m.mapa_visivel=true
						end
					end
					if m.exibe>0 then
						if m.nome_img~="ballon" and m.nome_img~="lock" then
							love.graphics.setColor(m.a,m.a,m.a,m.a)
							love.graphics.draw(m.img,m.x,m.y)
						else
							if m.nome_img=="ballon" then
								if m.explodido==false then
									love.graphics.setColor(m.a,m.a,m.a,m.a)
									love.graphics.draw(m.img,m.x,m.y)
								else
									if love.timer.getMicroTime()>=m.tempo_explosao+5 then
										mx,my,ml,ma=m.x,m.y,m.img:getWidth(),m.img:getHeight()
										if not checa_colisao(jx,jy,jl,ja,mx,my,ml,ma) then
											m.vel_x=.0025
											m.colisao=false
											m.explodido=false
											m.tempo_treme=0
											m.tempo_explosao=0
											m.x=m.ini_x
											m.qtd_explosao=0
											if m.cor=="green" then
												m.tempo_treme=love.timer.getMicroTime()+2.5
											elseif m.cor=="blue" then
												m.tempo_treme=love.timer.getMicroTime()+2
											elseif m.cor=="yellow" then
												m.tempo_treme=love.timer.getMicroTime()+1.5
											elseif m.cor=="red" then
												m.tempo_treme=love.timer.getMicroTime()+1
											end
										end
									end
								end
							elseif m.nome_img=="lock" then
								if m.explodido==true then m.a=0 end
								love.graphics.setColor(m.a,m.a,m.a,m.a)
								love.graphics.draw(m.img,m.x,m.y)
							end
						end

						if m.nome_img=="crate" or (m.nome_img=="lock" and m.explodido==false) then
							mundo:trata_crate_lock(i)
						end

					end
					if m.colisao_jogador==true then
						c=c+1
						jogador.mundo_escorrega=i

						if m.nome_img~="ground_sand" then
							jogador.vel_run_minimo=7
							if jogador.vel_run<7 then jogador.vel_run=7 end
						elseif m.nome_img=="ground_sand" then
							jogador.vel_run_minimo=5
						end
					end
					if m.colisao_moeda==true then
						cm=cm+1
					end
				end
			else
				alfa=m.a-100
				if alfa<=0 then alfa=0 end
				love.graphics.setColor(100,100,100,alfa)
				love.graphics.draw(m.img,m.x,m.y)
			end
		end
	end
	if c>1 then
		jogador.mundo_escorrega=0
		jogador.vel_x=0
	end
end

function mundo:testa_colisao_jogador(jx,jy)
	local jl,ja=img_jogador[jogador.frame]:getWidth(),img_jogador[jogador.frame]:getHeight()
	local ml,ma,x=0,0,0

	jogador.colisao=false
	jogador.objeto_colisao=""

	if jogador.vivo==false or jogador.afundando==true then
		return
	end

	for i,m in ipairs(mundo) do
		m.colisao_jogador=false
		if m.nome_img~="limite" and m.nome_img~="img_ceu" then
			if (m.x>=0 and m.x+m.img:getWidth()<=res_x) then
				mx,my,ml,ma=m.x,m.y,m.img:getWidth(),m.img:getHeight()
				if m.nome_img=="base" or string.find(m.nome_img,"ground")~=nil or m.nome_img=="block" or m.nome_img=="bridge" or string.find(m.nome_img,"bonus")~=nil or m.nome_img=="plank" or m.nome_img=="crate" or string.find(m.nome_img,"spikes")~=nil or m.nome_img=="water" or (m.nome_img=="ballon" and m.explodido==false) or (m.nome_img=="lock" and m.explodido==false) then
					if checa_colisao(jx,jy,jl,ja,mx,my,ml,ma) then
						m.colisao_jogador=true
						jogador.colisao=true
						jogador.posicao_colisao="on_top"
						if m.nome_img=="water" and jogador.y+ja<=my then
							jogador.direcao=""
							jogador.colisao=false
							jogador.afundando=true
							jogador.tempo_afundando=love.timer.getMicroTime()
							jogador.frame=22
							for i=1,6 do
								efeito:add(math.random(jx-10,jx+10),m.y-10,"bubbles",-1)
							end
							for i=1,6 do
								efeito:add(math.random(jx+jl-10,jx+jl+10),m.y-10,"bubbles",1)
							end
							return
						end
						if jogador.y>m.y+ma then
							jogador.posicao_colisao="on_bottom"
							if m.nome_img=="spikes_down" and jogador.atingido==false then
								jogador.frame=22
								if (jogador.moeda_ouro+jogador.moeda_prata+jogador.moeda_bronze)==0 then
									jogador.direcao=""
									jogador.colisao=false
									jogador.vivo=false
									jogador.vel_y=-16
									return
								else
									jogador.atingido=true
									jogador.tempo_atingido=love.timer.getMicroTime()
									moeda:libera_moeda()
								end
							end
						end
						if m.nome_img=="spikes" and jogador.atingido==false then
							if jogador.y+img_jogador[jogador.frame]:getHeight()<=m.y then
								jogador.frame=22
								if (jogador.moeda_ouro+jogador.moeda_prata+jogador.moeda_bronze)==0 then
									jogador.direcao=""
									jogador.colisao=false
									jogador.vivo=false
									jogador.vel_y=-16
									return
								else
									jogador.colisao=false
									jogador.atingido=true
									jogador.tempo_atingido=love.timer.getMicroTime()
									jogador.direcao="left"
									jogador.vel_y=-16
									moeda:libera_moeda()
								end
							end
						end
						if jogador.posicao_colisao=="on_top" then
							if m.nome_img=="bridge" then
								if math.abs(m.y-m.ini_y)<=5 then
									m.y=m.y+1
								end
							end
							if m.nome_img=="ground_snow" then
								if jogador.direcao=="right" then
									jogador.vel_deslizar=jogador.vel_deslizar+1
									if jogador.vel_deslizar>jogador.vel_run then jogador.vel_deslizar=jogador.vel_run end
								elseif jogador.direcao=="left" then
									jogador.vel_deslizar=jogador.vel_deslizar-1
									if jogador.vel_deslizar<-jogador.vel_run then jogador.vel_deslizar=-jogador.vel_run end
								end
							else
								if jogador.vel_deslizar<0 then
									jogador.vel_deslizar=jogador.vel_deslizar+1
									if jogador.vel_deslizar>0 then jogador.vel_deslizar=0 end
								elseif jogador.vel_deslizar>0 then
									jogador.vel_deslizar=jogador.vel_deslizar-1
									if jogador.vel_deslizar<0 then jogador.vel_deslizar=0 end
								end
							end
						end
						if jogador.posicao_colisao=="on_bottom" and m.nome_img=="bonus" and m.tipo=="" then
							m.tipo="hit_up"
						end
						if m.nome_img=="plank" then
							jogador.objeto_colisao="plank_"..m.tipo
						end
					else
						if math.abs(m.y-m.ini_y)>0 and m.nome_img=="bridge" then
							m.y=m.y-1
						end
					end
				end
			end
		end
	end

end

function mundo:trata_crate_lock(i)
	local jx,jy,jl,ja=jogador.x,jogador.y,img_jogador[jogador.frame]:getWidth(),img_jogador[jogador.frame]:getHeight()
	local ml,ma=0,0

	vx=0
	if jogador.direcao=="right" then
		vx=jogador.vel_run
	elseif jogador.direcao=="left" then
		vx=-jogador.vel_run
	end

	m=mundo[i]
	if (m.x>=0 and m.x+m.img:getWidth()<=res_x) or (m.y>=0 and m.y+m.img:getHeight()<=res_y) then
		ml=m.img:getWidth()
		ma=m.img:getHeight()
		if checa_colisao(jx+vx,jy,jl,ja,m.x,m.y,ml,ma) then
			if jx+jl<=m.x or jx>=m.x+ml then
				if m.nome_img=="crate" then
					if jogador.vel_run>jogador.vel_run_minimo then
						jogador.vel_run=jogador.vel_run-2
						if jogador.vel_run<jogador.vel_run_minimo then jogador.vel_run=jogador.vel_run_minimo end
					end
					jogador.colisao=false
					if jx+jl<=m.x then
						x=jogador.vel_run
					elseif jx>=m.x+ml then
						x=-jogador.vel_run
					end
					if not mundo:testa_colisao_crate(i,x) then
						m.x=m.x+x
						m.mapa_x=m.x
					end
				elseif m.nome_img=="lock" and m.explodido==false then
					jogador.colisao=true
					if jx+jl<=m.x or jx>=m.x+ml then
						if jogador.chave_verde==true and m.cor=="green" then
							mundo[i].explodido=true
							jogador.chave_verde=false
						elseif jogador.chave_azul==true and m.cor=="blue" then
							mundo[i].explodido=true
							jogador.chave_azul=false
						elseif jogador.chave_vermelha==true and m.cor=="red" then
							mundo[i].explodido=true
							jogador.chave_vermelha=false
						elseif jogador.chave_amarela==true and m.cor=="yellow" then
							mundo[i].explodido=true
							jogador.chave_amarela=false
						end
						if m.explodido==true then
							for i=1,5 do
								efeito:add(math.random(m.x-10,m.x+50),math.random(m.y-10,m.y+50),"estrela_lock",m.cor)
							end
							x=(m.x+(m.img:getWidth()/2))-11
							y=(m.y+(m.img:getHeight()/2))-22
							diamante:add(x,y,0)
							for i=1,10 do
								efeito:add(x+16,y+16,"luz_"..#diamante,i)
							end
						end
					end
				end
			end
		end
	end
end

function mundo:testa_colisao_crate(cr,vx)
	local crl,cra=mundo[cr].img:getWidth(),mundo[cr].img:getHeight()
	local crx,cry=0,mundo[cr].y
	local ml,ma=0,0

	for i,m in ipairs(mundo) do
		if i~=cr and m.nome_img~="limite" and m.nome_img~="img_ceu" then
			if (m.x>=-80 and m.x+m.img:getWidth()<=res_x+80) then
				if (m.nome_img=="base" or string.find(m.nome_img,"ground")~=nil or m.nome_img=="block" or m.nome_img=="bridge" or string.find(m.nome_img,"bonus")~=nil or m.nome_img=="plank" or m.nome_img=="crate" or string.find(m.nome_img,"spikes")~=nil) or m.nome_img=="ballon" or (m.nome_img=="lock" and m.explodido==false) then
					ml=m.img:getWidth()
					ma=m.img:getHeight()

					crx=mundo[cr].x --+vx
					if crx>0 then dist=math.floor((crx+70)-m.x) end
					if crx<0 then dist=math.floor(crx-(m.x+70)) end
					if dist<vx then
						crx=crx+7
					else
						crx=crx+vx
					end
					if checa_colisao(crx,cry,crl,cra,m.x,m.y,ml,ma) or crx<mundo[1].x or crx+70>mundo[#mundo].x then
						return true
					end
				end
			end
		end
	end
	return false
end

function mundo:testa_colisao_moeda(mo)
	local mol,moa=moeda[mo].img:getWidth(),moeda[mo].img:getHeight()
	local mox=moeda[mo].x+moeda[mo].vel_x
	local moy=moeda[mo].y+moeda[mo].vel_y
	local ml,ma=0,0

	for i,m in ipairs(mundo) do
		if m.nome_img~="limite" and m.nome_img~="img_ceu" then
			if (m.x>=-80 and m.x+m.img:getWidth()<=res_x+80) then
				if m.nome_img=="base" or string.find(m.nome_img,"ground")~=nil or m.nome_img=="block" or m.nome_img=="bridge" or string.find(m.nome_img,"bonus")~=nil or m.nome_img=="plank" or m.nome_img=="crate" or string.find(m.nome_img,"spikes")~=nil or m.nome_img=="ballon" or m.nome_img=="lock" then
					ml=m.img:getWidth()
					ma=m.img:getHeight()
					if (m.x+ml>=0 and m.x<=res_x) or (m.y+ma>=0 and m.y<=res_y) then
						if checa_colisao(mox,moy,mol,moa,m.x,m.y,ml,ma) then
							if moeda[mo].x+moeda[mo].img:getWidth()<m.x or moeda[mo].x>m.x+m.img:getWidth() then
								moeda[mo].vel_x=moeda[mo].vel_x*-1
							else
								moeda[mo].colisao=true
								return
							end
						end
					end
				end
			end
		end
	end
end

function mundo:testa_colisao_inimigo(f)
	local fl,fa=inimigo[f].img:getWidth(),inimigo[f].img:getHeight()
	local fx=inimigo[f].x+inimigo[f].vel_x
	local fy=inimigo[f].y+inimigo[f].vel_y
	local ml,ma=0,0

	if #inimigo>0 then
		for i,m in ipairs(mundo) do
			if m.nome_img~="limite" and m.nome_img~="img_ceu" then
				if (m.x>=-80 and m.x+m.img:getWidth()<=res_x+80) then
					if string.find(m.nome_img,"ground")~=nil or m.nome_img=="bridge" or m.nome_img=="block" or string.find(m.nome_img,"bonus")~=nil or m.nome_img=="plank" or m.nome_img=="crate" or string.find(m.nome_img,"spikes")~=nil or string.find(m.nome_img,"water")~=nil or m.nome_img=="ballon" or m.nome_img=="lock" then
						ml=m.img:getWidth()
						ma=m.img:getHeight()
						if (m.x+ml>=0 and m.x<=res_x) or (m.y+ma>=0 and m.y<=res_y) then
							if checa_colisao(fx,fy,fl,fa,m.x,m.y,ml,ma) then
								inimigo[f].colisao=true
							end
						end
					end
				end
			end
		end
	end
end


function mundo:atualiza_posicao_x()
	val_x_atualiza_mundo=jogador.vel_run
	if string.find(jogador.direcao,"right")~=nil then
		if mundo[#mundo].x+70<res_x+jogador.vel_run then val_x_atualiza_mundo=math.abs((res_x)-(mundo[#mundo].x+70)) end
	end
	if string.find(jogador.direcao,"left")~=nil then
		if math.abs(mundo[1].x)<jogador.vel_run then val_x_atualiza_mundo=math.abs(mundo[1].x) end
	end
	for i,m in ipairs(mundo) do
		if string.find(jogador.direcao,"right")~=nil then
			m.x=m.x-val_x_atualiza_mundo
			m.ini_x=m.ini_x-val_x_atualiza_mundo
		elseif string.find(jogador.direcao,"left")~=nil then
			m.x=m.x+val_x_atualiza_mundo
			m.ini_x=m.ini_x+val_x_atualiza_mundo
		end
	end
end

function mundo:exibe_mapa()
    love.graphics.scale(0.3,0.3)
	if fim_x_mapa<(res_x*3.32)+25 then move_mapa="" end


	cenarioatras:exibe_mapa()

	for i,m in ipairs(mundo) do
		if move_mapa=="left" then
			if mundo[1].mapa_x<0 then m.mapa_x=m.mapa_x+7 end
		elseif move_mapa=="right" then
			if mundo[#mundo].mapa_x+70>(res_x*3.32)+25 then m.mapa_x=m.mapa_x-7 end
		end

		if m.nome_img~="limite" then
			alfa=0
			if m.mapa_visivel==true then alfa=255 end
			love.graphics.setColor(255,255,255,alfa)
			love.graphics.draw(m.img,m.mapa_x,m.y+300)
		end
	end

	cenariofrente:exibe_mapa()

end

function mundo:exibe_icones()
	if exibe_mapa then return end

	if jogador.chave_verde==true then
		love.graphics.setColor(255,255,255,255)
	else
		love.graphics.setColor(255,255,255,100)
	end
	love.graphics.draw(img_chave_verde,10,5)

	if jogador.chave_azul==true then
		love.graphics.setColor(255,255,255,255)
	else
		love.graphics.setColor(255,255,255,100)
	end
	love.graphics.draw(img_chave_azul,60,5)

	if jogador.chave_vermelha==true then
		love.graphics.setColor(255,255,255,255)
	else
		love.graphics.setColor(255,255,255,100)
	end
	love.graphics.draw(img_chave_vermelha,110,5)

	if jogador.chave_amarela==true then
		love.graphics.setColor(255,255,255,255)
	else
		love.graphics.setColor(255,255,255,100)
	end
	love.graphics.draw(img_chave_amarela,160,5)

	local x=res_x-34
	for i=1,jogador.max_vidas do
		love.graphics.setColor(255,255,255,255)
		if jogador.vidas<i then love.graphics.setColor(255,255,255,100) end
		love.graphics.draw(img_jogador[23],x,5)
		x=x-30
	end

	love.graphics.setColor(255,255,255,255)
	local f,t,y=0,love.timer.getMicroTime(),45
	x=res_x-37
	for i=1,jogador.fase_total_diamantes do
		local quad = love.graphics.newQuad(icones_diamantes[i].f*32,0,32,32,256,32)
		love.graphics.drawq(img_diamante[0],quad,x,y)
		if love.timer.getMicroTime()>=icones_diamantes[i].t+.050 then
			icones_diamantes[i].t=love.timer.getMicroTime()
			icones_diamantes[i].f=icones_diamantes[i].f+1
			if icones_diamantes[i].f==8 then
				icones_diamantes[i].f=0
			end
		end
		x=x-32
	end

end

function mundo:reset()

	local mapa=love.image.newImageData("mapas/mapa_"..fase.."")
	local ml,ma=mapa:getWidth(),mapa:getHeight()
	local x,y=0,0

	jogador.level_completo=false

	efeito:apaga("")
	diamante:apaga()
	moeda:apaga()
	chave:apaga()
	cenariofrente:apaga()
	cenarioatras:apaga()
	tempo:apaga()
	colinas:apaga()
	mundo:apaga()

	self:add(0,0,"limite","","")

	for i=0,ml-1 do
		x=70*i
		for j=0,ma-1 do
			y=70*j
			r,g,b,a=mapa:getPixel(i,j)

			if r==0 and g==0 and b==0 then
				jogador.x = x
				jogador.y = y
			end

			if r==5 and g==5 and b==5 then ambiente="sol" end
			if r==10 and g==10 and b==10 then ambiente="nublado" end
			if r==15 and g==15 and b==15 then ambiente="chuva" end
			if r==20 and g==20 and b==20 then ambiente="noite" end
			if r==25 and g==25 and b==25 then ambiente="noite_chuva" end
			if r==30 and g==30 and b==30 then ambiente="neve" end
			if r==35 and g==35 and b==35 then ambiente="noite_neve" end
			if r==40 and g==40 and b==40 then ambiente="deserto" end

			ok=0
			if r==255 and g==128 and b==64 then self:add(x,y,"ground","",""); ok=1 end
			if r==100 and g==100 and b==0 then self:add(x,y,"ground_sand","",""); ok=1 end
			if r==0 and g==128 and b==128 then self:add(x,y,"ground","","") end
			if r==128 and g==64 and b==0 then self:add(x,y,"ground_dirt","","") end

			if r==192 and g==192 and b==192 then self:add(x,y,"ground_snow","",""); ok=1 end
			if r==128 and g==128 and b==128 then self:add(x,y,"ground_rock","","") end
			if r==130 and g==130 and b==130 then self:add(x,y,"ground_rock_2","",""); ok=2 end

			if r==200 and g==100 and b==64 then self:add(x,y,"block","","") end

			if r==128 and g==0 and b==0 then self:add(x,y,"plank","vert","") end

			--chaves
			if r==200 and g==0 and b==0 then self:add(x,y,"bonus","","red") end
			if r==200 and g==200 and b==0 then self:add(x,y,"bonus","","yellow") end
			if r==0 and g==200 and b==0 then self:add(x,y,"bonus","","green") end
			if r==0 and g==0 and b==200 then self:add(x,y,"bonus","","blue") end
			if r==255 and g==0 and b==255 then self:add(x,y,"bonus","","") end

			--fechaduras
			if r==255 and g==0 and b==0 then
				self:add(x,y,"lock","","red")
				jogador.fase_total_diamantes=jogador.fase_total_diamantes+1
				icones_diamantes:add()
			end
			if r==255 and g==255 and b==0 then
				self:add(x,y,"lock","","yellow")
				jogador.fase_total_diamantes=jogador.fase_total_diamantes+1
				icones_diamantes:add()
			end
			if r==0 and g==255 and b==0 then
				self:add(x,y,"lock","","green")
				jogador.fase_total_diamantes=jogador.fase_total_diamantes+1
				icones_diamantes:add()
			end
			if r==0 and g==0 and b==255 then
				self:add(x,y,"lock","","blue")
				jogador.fase_total_diamantes=jogador.fase_total_diamantes+1
				icones_diamantes:add()
			end

			if r==128 and g==128 and b==64 then self:add(x,y,"crate","","") end

			if r==0 and g==128 and b==255 then self:add(x,y+25,"water","","") end
			if r==0 and g==128 and b==200 then self:add(x,y,"deep_water","","") end
			if r==0 and g==128 and b==128 then self:add(x,y,"deep_water","","") end

			if ok>0 then
				pos=math.random(0,1)
				obj=math.random(1,22)
				if pos==0 then
					if obj==1 then cenarioatras:add(x,y-61,"fence") end
					if obj==2 then cenarioatras:add(x,y-61,"fence_broken") end
					if obj==3 and ok==1 then cenarioatras:add(x,y-26,"bush") end
					if obj==4 and ok==1 then cenarioatras:add(x+(35/2),y-40,"grass_1") end
					if obj==5 and ok==1 then cenarioatras:add(x+(35/2),y-40,"grass_2") end
					if obj==6 then cenarioatras:add(x,y-41,"rock_1") end
					if obj==7 then cenarioatras:add(x,y-41,"rock_2") end
					if obj==8 then cenarioatras:add(x+(39/2),y-34,"shroom") end
				end
				if pos==1 then
					if obj==1 then cenariofrente:add(x,y-61,"fence") end
					if obj==2 then cenariofrente:add(x,y-61,"fence_broken") end
					if obj==3 and ok==1 then cenariofrente:add(x,y-26,"bush") end
					if obj==4 and ok==1 then cenariofrente:add(x+(35/2),y-40,"grass_1") end
					if obj==5 and ok==1 then cenariofrente:add(x+(35/2),y-40,"grass_2") end
					if obj==6 then cenariofrente:add(x,y-41,"rock_1") end
					if obj==7 then cenariofrente:add(x,y-41,"rock_2") end
					if obj==8 then cenariofrente:add(x+(39/2),y-34,"shroom") end
				end
			end

			if r==0 and g==128 and b==0 then
				if string.find(ambiente,"neve")==nil then
					if ambiente~="deserto" then
						colinas:add(x,y-20,"hill_long")
					else
						colinas:add(x,y-20,"hill_long_desert")
					end
				else
					colinas:add(x,y-14,"hill_long_snow")
				end
			end
			if r==0 and g==100 and b==0 then
				if string.find(ambiente,"neve")==nil then
					if ambiente~="deserto" then
						colinas:add(x,y-5,"hill_short")
					else
						colinas:add(x,y-5,"hill_short_desert")
					end
				else
					colinas:add(x,y-5,"hill_short_snow")
				end
			end


			if r==90 and g==90 and b==90 then self:add(x,y+35,"spikes","up","") end
		end
	end

	if fase==1 then tempo_fase=30 end
	if fase==2 then tempo_fase=33 end
	if fase==3 then tempo_fase=60 end

	--[[self:add(250,200,"ground","","")
	self:add(x,500,"ground","","")
	x=x+self[#self].img:getWidth()
	self:add(x,500,"ground","","")
	x=x+self[#self].img:getWidth()
	self:add(x,430,"ground","","")
	x=x+self[#self].img:getWidth()
	for i=4,45 do
		a="ground"
		if i==45 then a=a.."_dirt" end
		self:add(x,y,a,"")
		if i==10 then
			self:add(x+70,y+190,"ground","","")
			self:add(x+140,y+190,"ground","","")
			self:add(x+210,y+190,"ground","","")
			x=x+140
		end
		x=x+self[#self].img:getWidth()
	end

	self:add(1680,y-70,"crate","","")
    self:add(x-70,y-70,"ground","","")

	self:add(470,650,"ground","","")
	self:add(540,650,"ground","","")
	self:add(970,700,"ground","","")
	self:add(1040,700,"ground","","")
	self:add(1250,700,"ground","","")
	self:add(1320,700,"ground","","")
	self:add(1520,700,"ground","","")
	self:add(1590,700,"ground","","")
	self:add(1660,700,"ground","","")
	self:add(1730,700,"ground","","")
	self:add(800,800,"ground","","")
	self:add(730,800,"ground","","")

	self:add(1420,800,"plank","vert","")

	self:add(950,220,"ground","","")
	self:add(1300,220,"ground","","")
	for i=1,4 do
		self:add(950+(70*i),220,"bridge","","")
	end

	x,y=1730,600
	for i=1,50 do
		x=x+70
		self:add(x,y,"ground","","")
		if i>3 and i<9 then
			y=y+60
		end
		if i>9 and i<15 then
			y=y-60
		end
	end

	self:add(x-1400,y-190,"bonus","","")
	self:add(450,100,"bonus","","red")
	self:add(x-1000,y-190,"bonus","","yellow")
	self:add(180,730,"bonus","","blue")
	self:add(100,1000,"ground","","")
	self:add(170,1000,"ground","","")
	self:add(240,1000,"ground","","")
	self:add(310,930,"ground","","")
	self:add(380,860,"ground","","")

	self:add(511,390,"spikes_down","down","")
	self:add(1668,665,"spikes","up","")

	self:add(3000,y-16,"base","","")


	xx=870
	for j=1,6 do
		self:add(xx+(70*j),1100,"ground","","")
	end

	self:add(1110,725,"water","","")
	self:add(1180,725,"water","","")
	y=770
	for i=1,10 do
		self:add(1110,y,"deep_water","","")
		self:add(1180,y,"deep_water","","")
		y=y+70
		if y>res_y then break end
	end

	self:add(2680,250,"lock","","red")
	self:add(2880,250,"lock","","blue")

	self:add(2000,100,"ballon","esq","green")
	self:add(2200,100,"ballon","esq","red")]]

	self:add(x,0,"limite","","")

	tempo:ceus()
	tempo:nuvens(x)

	fim_x_mapa=x+70

	if string.find(ambiente,"chuva")~=nil then
		for i=1,300 do
			tempo:add(math.random(-100,1708),math.random(-800,0),"chuva")
		end
	end
	if string.find(ambiente,"neve")~=nil then
		for i=1,300 do
			tempo:add(math.random(-100,1708),math.random(-800,0),"neve")
		end
	end
end

function mundo:apaga()
	for i=1,#mundo do
		mundo[i]=nil
	end
end

function icones_diamantes:apaga()
	for i=1,#icones_diamantes do
		icones_diamantes[i]=nil
	end
end

function icones_diamantes:add()
	icones_diamantes[#icones_diamantes+1]={
		t=love.timer.getMicroTime(),
		f=0
	}
end
