
tempo = {}
nuvem={}

img_ceu = love.graphics.newCanvas()
img_fundo = love.graphics.newCanvas()

function tempo:add(x,y,tp)
	self[#tempo+1]={
		x=x,
		y=y,
		vel_y=math.random(1,3),
		tamanho=math.random(1,7),
		angulo=80,
		tipo=tp
	}
	if self[#tempo].tipo=="neve" then
		self[#tempo].tamanho=math.random(1,4)
	end
end

function tempo:draw()

	for i=1,#tempo do
		t=tempo[i]
		if not paused then
			t.x=(-math.cos(t.angulo)*3)+t.x
			t.y=(-math.sin(t.angulo)*t.vel_y)+t.y
			if t.y>res_y then
				t.y=math.random(-100,0)
				t.x=math.random(-100,res_x)
				t.vel_y=math.random(1,3)
			end
		end
		if t.tipo=="chuva" then
			love.graphics.line(t.x,t.y,t.x+3,t.y+t.tamanho)
		else
			love.graphics.circle("fill",t.x,t.y,t.tamanho,20)
		end
	end

end

function tempo:ceus()
	local r,g,b,c

	love.graphics.setCanvas(img_ceu)
	love.graphics.setPoint(2, "rough")
	if ambiente=="sol" or ambiente=="deserto" then
		for x=0,9 do
			r,g,b,c=5,70,180,0
			for y=0,(res_y-70) do
				love.graphics.setColor(r,g,b,200)
				love.graphics.point(x,y)
				c=c+1
				if c==3 then
					c=0
					r=r+1
					if r>140 then r=140 end
					g=g+1
					if g>205 then g=205 end
					b=b+1
					if b>255 then b=255 end
				end
			end
		end
	end

	if ambiente=="nublado" or ambiente=="chuva" or ambiente=="neve" then
		for x=0,9 do
			r,g,b,c=80,80,80,0
			if ambiente=="chuva" then
				r,g,b=50,50,50
			end
			for y=0,(res_y-70) do
				love.graphics.setColor(r,g,b,200)
				love.graphics.point(x,y)
				c=c+1
				if c==3 then
					c=0
					r=r+1
					if r>180 then r=180 end
					g=g+1
					if g>180 then g=180 end
					b=b+1
					if b>180 then b=180 end
				end
			end
		end
	end

	if ambiente=="noite" then
		for x=0,9 do
			r,g,b,c=0,0,0,0
			for y=0,(res_y-70) do
				love.graphics.setColor(r,g,b,200)
				love.graphics.point(x,y)
				c=c+.35
				if c>=3 then
					c=0
					r=r+1
					if r>122 then r=122 end
					g=g+1
					if g>54 then g=54 end
					b=b+1
					if b>122 then b=122 end
				end
			end
		end
	end

	if ambiente=="noite_chuva" or ambiente=="noite_neve" then
		for x=0,9 do
			r,g,b,c=0,0,0,0
			for y=0,(res_y-70) do
				love.graphics.setColor(r,g,b,200)
				love.graphics.point(x,y)
				c=c+.35
				if c>=3 then
					c=0
					r=r+1
					if r>100 then r=100 end
					g=g+1
					if g>100 then g=100 end
					b=b+1
					if b>100 then b=100 end
				end
			end
		end
	end

	love.graphics.setPoint(2, "rough")
	love.graphics.setCanvas(img_fundo)
	for x=0,9 do
		alfa=120
		for y=0,799 do
			love.graphics.setColor(185,122,87,alfa)
			love.graphics.point(x,y)
			alfa=alfa-.1
		end

	end
	love.graphics.setCanvas()
	love.graphics.setPoint(1, "rough")

	tempo_trovao[0]=love.timer.getMicroTime()+99999
	tempo_trovao[1]=love.timer.getMicroTime()+99999
	tempo_trovao[2]=love.timer.getMicroTime()+99999
	x=math.random(3)
	if ambiente=="sol" or ambiente=="deserto" then
		campo_visao=500
	elseif ambiente=="nublado" or ambiente=="neve" then
		campo_visao=400
	elseif ambiente=="chuva" then
		campo_visao=300
	elseif ambiente=="noite" then
		campo_visao=250
	elseif ambiente=="noite_chuva" or ambiente=="noite_neve" then
		campo_visao=200
	end

	if string.find(ambiente,"chuva") then
		local tmp=love.timer.getMicroTime()+math.random(2,5)
		for i=1,x do
			tempo_trovao[i-1]=tmp+(math.random(1,4)/10)
		end
	end

end

function tempo:nuvens(px)
	for i=1,#nuvem do
		nuvem[i]=nil
	end
	if ambiente=="sol" or ambiente=="noite" then
		for i=1,10 do
			dir=math.random(-1,1)
			if dir==0 then	dir=1 end
			nuvem[#nuvem+1] = {
				x=math.random(px),
				y=math.random(150),
				img=love.graphics.newImage("gfx/cloud_"..(math.random(1,3))..".png"),
				vel_x=((math.random()/10)*2)*dir,
				alfa=0
			}
		end
	end
end


function tempo:apaga()
	for i=1,#tempo do
		tempo[i]=nil
	end
end
