inimigo = {}

function inimigo:add(x,y,tipo)

	self[#self+1]= {
		x=x,
		y=y,
		vel_x=vx,
		vel_y=vy,
		tipo=tipo,
		angulo=0,
		tamanho=0,
		tempo=love.timer.getMicroTime(),
		exibe=true,
		colisao=false,
		img=""
	}

	if tipo=="ball" then
		img="ballBlue"
		dir=1
		if jogador.x<x then dir=-1 end
		vx=(math.random(5,9))*dir
		if math.random(1,4)<3 then
			img="ballGrey"
			vx=(math.random(1,5))*dir
		end
		self[#self].img=love.graphics.newImage("gfx/"..img..".png")
		self[#self].vel_y=-math.random(7,12)
		self[#self].vel_x=vx
	end
end

function inimigo:draw()
	for i=1,#inimigo,1 do
		if inimigo[i].exibe==true then
			f=inimigo[i]
			love.graphics.draw(f.img,f.x,f.y)
		end
	end

	return true
end

function inimigo:testa_colisao_mundo()
	local jx,jy,jl,ja=jogador.x,jogador.y,img_jogador[jogador.frame]:getWidth(),img_jogador[jogador.frame]:getHeight()
	for j=1,#inimigo,1 do
		if inimigo[j]~=nil then
			f=inimigo[j]
			if f.colisao==false then
				if f.tipo=="ball" then
					f.colisao=false
					f.vel_y=f.vel_y+gravidade
					mundo:testa_colisao_inimigo(j)
					if f.colisao==false then
						f.x=f.x+f.vel_x
						f.y=f.y+f.vel_y
						if f.y>res_y then
							inimigo[j].exibe=false
						end
						if checa_colisao(jx,jy,jl,ja,f.x,f.y,22,22) then
							f.colisao=true
							f.exibe=false
							jogador.colisao=false
							if jogador.atingido==false then
								jogador.frame=22
								if (jogador.moeda_ouro+jogador.moeda_prata+jogador.moeda_bronze)==0 then
									jogador.colisao=false
									jogador.vivo=false
									jogador.vel_y=-16
									return
								else
									jogador.vel_y=-7
									jogador.atingido=true
									jogador.tempo_atingido=love.timer.getMicroTime()
									moeda:libera_moeda()
								end
							end
							efeito:add(f.x,f.y,"sparkle")
						end
					else
						f.vel_x=0
						f.vel_y=0
						inimigo[j].exibe=false
						efeito:add(f.x,f.y,"sparkle")
					end
				end
			end
		end
	end
end

function inimigo:atualiza_posicao_x()
	for i=1,#inimigo,1 do
		if inimigo[i]~=nil then
			f=inimigo[i]
			if string.find(jogador.direcao,"right")~=nil then
				f.x=f.x-val_x_atualiza_mundo
			elseif string.find(jogador.direcao,"left")~=nil then
				f.x=f.x+val_x_atualiza_mundo
			end
		end
	end
end

function inimigo:cria_tiro(m)
	if love.timer.getMicroTime()>=tempo_tiro+3 then
		mx,my,ml=mundo[m].x,mundo[m].y,mundo[m].img:getWidth()
		tempo_tiro=love.timer.getMicroTime()
		x=mx+((ml/2)-11)
		y=my-25
		inimigo:add(x,y,"ball")
	end
end
